Attribute VB_Name = "mdlConvertMiladiToShamsi"
Option Explicit
'//////////////////////////////////////////////////////////////////////////////////////
'                                        Information
' *** Reng Date Miladi (Input)   Mon/Day/years'
' *** Reng Date Shamci (output)   years/Mon/Day'
'Output Function at MainConvertDate()

'\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


'                              ***    Motegayers     ***
Dim MonthMil, Daymil As String * 2
Dim YearMil As String * 4

Dim MonthSha, DaySha As String * 2
Dim YearSha As String * 4

'--------------------------------------------------------------------------




'**********************     MAIN      ******************
Public Function ConvertDateToShamci() As String
    
    'Get date miladi
    MonthMil = Month(Date)
    Daymil = Day(Date)
    YearMil = Year(Date)
    
    '   //  Month Shmci
    Select Case MonthMil
        
        Case "1":       'Jan
            If (Daymil >= 21) Then
                MonthSha = 11
            Else: MonthSha = 10
            End If
        
        Case "2":       'Feb
            If (Daymil >= 20) Then
                MonthSha = 12
            Else: MonthSha = 11
            End If
        
        Case "3":       'Mar
            If (Daymil >= 21) Then
                MonthSha = 1
            Else: MonthSha = 12
            End If
        
        Case "4":       'Apr
            If (Daymil >= 21) Then
                MonthSha = 2
            Else: MonthSha = 1
            End If
        
        Case "5":       'May
            If (Daymil >= 22) Then
                MonthSha = 3
            Else: MonthSha = 2
            End If
        
        Case "6":       'Jun
            If (Daymil >= 22) Then
                MonthSha = 4
            Else: MonthSha = 3
            End If
        
        Case "7":       'Jul
            If (Daymil >= 23) Then
                MonthSha = 5
            Else: MonthSha = 4
            End If
        
        Case "8":       'Aug
            If (Daymil >= 23) Then
                MonthSha = 6
            Else: MonthSha = 5
            End If
        
        Case "9":       'Sep
            If (Daymil >= 23) Then
                MonthSha = 7
            Else: MonthSha = 6
            End If
        
        Case "10":      'Oct
            If (Daymil >= 23) Then
                MonthSha = 8
            Else: MonthSha = 7
            End If
        
        Case "11":      'Nov
            If (Daymil >= 22) Then
                MonthSha = 9
            Else: MonthSha = 8
            End If
        
        Case "12":      'Dec
            If (Daymil >= 22) Then
                MonthSha = 10
            Else: MonthSha = 9
            End If
    
    End Select
    '//----------------------------------------------------- End Month Shmci
     
    '//  Day Shamci
    Select Case MonthMil
        
        Case "1":       'Jan
            If (Daymil <= 20) Then
                DaySha = Daymil + 10
            Else: DaySha = Daymil - 10
            End If
        
        Case "2":       'Feb
            If (Daymil <= 19) Then
                DaySha = Daymil + 11
            Else: DaySha = Daymil - 19
            End If
        
        Case "3":       'Mar
            If (Daymil <= 20) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 20
            End If
        
        Case "4":       'Apr
            If (Daymil <= 20) Then
                DaySha = Daymil + 11
            Else: DaySha = Daymil - 20
            End If
        
        Case "5":       'May
            If (Daymil <= 21) Then
                DaySha = Daymil + 10
            Else: DaySha = Daymil - 21
            End If
        
        Case "6":       'Jun
            If (Daymil <= 21) Then
                DaySha = Daymil + 10
            Else: DaySha = Daymil - 21
            End If
        
        Case "7":       'Jul
            If (Daymil <= 22) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 22
            End If
        
        Case "8":       'Aug
            If (Daymil <= 22) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 22
            End If
        
        Case "9":       'Sep
            If (Daymil <= 22) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 22
            End If
        
        Case "10":      'Oct
            If (Daymil <= 22) Then
                DaySha = Daymil + 8
            Else: DaySha = Daymil - 22
            End If
        
        Case "11":      'Nov
            If (Daymil <= 21) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 21
            End If
        
        Case "12":      'Dec
            If (Daymil <= 21) Then
                DaySha = Daymil + 9
            Else: DaySha = Daymil - 21
            End If
        
    End Select
    '//-------------------------------------------------------------  Day Shamci
    
    '//  Years Shamci
        
    If (MonthMil = 3) And (Daymil <= 20) Then
        YearSha = Trim(Str(Int(YearMil) - 622))
    ElseIf (MonthMil = 3) And (Daymil > 20) Then
        YearSha = Trim(Str(Int(YearMil) - 621))
    
    ElseIf (MonthMil = 1) Then
        YearSha = Trim(Str(Int(YearMil) - 622))
   
    ElseIf (MonthMil >= 4) And (MonthMil <= 12) Then
        YearSha = Trim(Str(Int(YearMil) - 621))
    End If
       
    '//-------------------------------------------------------------  Years Shamci
    
    ConvertDateToShamci = YearSha & "/" & MonthSha & "/" & DaySha
End Function


